package heasarc.w3browse.plot;

import java.awt.*;
import java.awt.event.*;

/** This class displays an error dialog box. 
 * @author Saima Zobair (RITSS)
 */
public class ErrorDialog extends Dialog implements ActionListener {
  /////////////////////////////////////////////////////////////////
  ///                   class variables                         ///
  /** Dississ button */
  protected Button doDismiss;

  /** true if applet is runing */
  protected boolean isApplet = false;
  
  /////////////////////////////////////////////////////////////////
  ///                   constructor                             ///
  /** Constructor for ErrorDialog */
  public ErrorDialog(boolean isApplet) {
     super(new Frame(),"ERROR",true);
     this.isApplet = isApplet;
     setFont(new Font("Helvetica",Font.BOLD,16));
     setBackground(new Color(200,200,200));
     setForeground(new Color(200,100,100));

     add("North", new Label("ERROR",Label.CENTER));

     doDismiss = new Button("Press to Continue");
     doDismiss.setForeground(Color.black);
     doDismiss.addActionListener(this);
     doDismiss.setBackground(new Color(225,200,200));
     add("South",doDismiss);
  } 

  /////////////////////////////////////////////////////////////////
  ///                   public methods                          ///
  /** This routine does the event handling  for the dimiss button*/
  public void actionPerformed(ActionEvent e){

    if (e.getActionCommand() == "Press to Continue") {
       dispose();
    }
  }
  /** This routine displays the error message in the dialog box
   * @param message string containing the error message
   */
  public void display(String message) {
    if (isApplet) {
      Label err = new Label(message,Label.CENTER);
      err.setForeground(Color.blue);
      err.setFont(new Font("Helvetica",Font.ITALIC,14));
      add("Center",err);
      setSize(420,150);
      this.setVisible(true);
    } else {
      System.out.println("Error: " + message);
      System.exit(1);
    } 
  }

}

