package heasarc.w3browse.plot;

import javax.swing.*;
import java.awt.*;
import java.applet.*; 
import java.awt.event.*; 
//import ptolemy.plot.PlotApplet;

import heasarc.w3browse.*;

//public class W3PlotA extends PlotApplet 
public class W3PlotA extends JApplet 
{ // Opens class
 
  private JTabbedPane tabbedPane; 

  /** Contains the W3Browse data to allow plotting */ 
  protected HeasarcQuery hquery;
    
  /** Indicates if User is running an application or applet */
  public boolean isApplet = true; 
    
  /** Plot specification structure. */
  public PlotSpecs plotspecs;

      
  private String url;
  private String postData;
    
  /** Contains args[] strings if the class is called as an application*/
  String[]  input;
    
  /** Parameter name for right ascension in table */
  public String ra;
  /** Parameter name for declination in table */
  public String dec;

  private AppletContext appletC;

  public W3PlotA() { // Opens contructor
  }
      
      //Create a frame object to add the application
      //GUI components to.
    
  /** The Applet's init() method reads and instantiates the hquery
   *  object which starts up the database query to load it with data
   */ 
  public void init() {


     if (isApplet) {
	  url = getParameter("url");
	  postData = "fields=all&dispmode=StreamDisplay&request=" +
		    getParameter("request");
          appletC = getAppletContext();
	  try {
              hquery = new HeasarcQuery(url, postData);
	  } catch (Exception e) {
	      System.err.println("Unable to set up query.  " +
			"Exiting operation."+e);
	      return;
	  }
	  ra  = getParameter("ra");
	  dec = getParameter("dec");
     }
      
     //setSize(700, 690);
     //setSize(730, 550);
     setBackground(Color.white);
                  
     //--- Tabbed pane with panels for Jcomponents
     tabbedPane = new JTabbedPane(SwingConstants.TOP);
         
     //--- adds individual tabs to the tabbedpane object.
     populateTabbedPane();
         
     //Calls the method that builds the menu  if application
     if (!isApplet) {
        buildMenu();
     }
     setVisible(true);
         
  } //--- ends init
         
  private void populateTabbedPane() { // Opens populateTabbedPane method
     // Create tabs with titles
     PlotOptions plotOptions = new  PlotOptions(hquery, plotspecs, isApplet, 
		ra, dec, url,appletC);
     PlotPane plotPane    = new  PlotPane(isApplet);
     tabbedPane.addTab("Plot Options Panel",
                               null,
                               plotOptions,
                               "Click to select Plotting Options");
                               
     tabbedPane.addTab("Plot Panel",
                               null,
                               plotPane,
                               "Click here to see most recent plot");
                               
                               
     getContentPane().add(tabbedPane);
     plotOptions.setPlotPane(plotPane);
     tabbedPane.setSelectedComponent(plotOptions);

  } //Ends populateTabbedPane method
          
         
  private void buildMenu() { // Opens buildMenu method
      JMenuBar mb = new JMenuBar();
      JMenu menu = new JMenu("File");
      JMenuItem item = new JMenuItem("Exit");
           
      //--- Closes the application from the Exit menu item.
      item.addActionListener(new ActionListener() { 
         //--- Opens addActionListener method
         public void actionPerformed(ActionEvent e) { 
            //--- Opens actionPerformed method
            System.exit(0);
         } //--- Closes actionPerformed method
              
      }); //--- Closes addActionListener method
             
      menu.add(item);
      mb.add(menu);
      setJMenuBar(mb);
             
  } //Ends the buildMenu method
          

  
  public static void main(String[] args) { 
     // Create an instance of the applet class.
     JApplet plotApplet = new W3PlotA();


     // Construct a JFrame.
      final JFrame frame = new JFrame("Browse Plotting");
      frame.setContentPane(plotApplet.getContentPane());

      //frame.setJMenuBar(plotApplet.getJMenuBar());
      frame.addWindowListener(new WindowAdapter() { 
          // Opens addWindowListener method
          public void windowClosing(WindowEvent e)
          { // Opens windowClosing method
             System.exit(0);
          } // Closes windowClosing method
         }); // Closes addWindowListener method
         
      //frame.setSize(765, 690);
      //frame.setSize(730, 550);
     // Send the applet an init() message.
     plotApplet.init();

     frame.setBackground(Color.white); 
     frame.setVisible(true);

     // Show the frame.
     frame.show();

     // Invoke the applet's start() method.
     // This line can be omitted if the applet
     // does not define a start method.
     //plotApplet.start();
  }
    

                     
 } //Ends class           
