package heasarc.w3browse.plot;

/**
 *           W3Browse Plotting                                  **
 *                                                              **
 * SOURCE: CreateGif.java                                       **
 *                                                              **
 * @author Saima Zobair (RITSS)   saima@lheamail.gsfc.nasa.gov  **
 *                                                              **
 *****************************************************************/

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import ptolemy.plot.*;
//import GIFEncoder;

/**  This class creates the gif file for a defined plot. 
 */ 
public class CreateGif extends Frame{

  /////////////////////////////////////////////////////////////////
  ///                   class variables                         ///
  /** This variable contains the plot */
  public Plot myplot;

  /////////////////////////////////////////////////////////////////
  ///                      constructor                          ///
  /** Constructor sets the frame size and initializes plot */  
  public CreateGif(Plot plot){
    setSize(100,100);
    this.myplot = plot;
  }

  /////////////////////////////////////////////////////////////////
  ///                      methods                              ///
  /** Creates a gif file with the plot in it */
  public void makeGif(String pnum) throws IOException,AWTException{
    Panel c = new Panel();
    c.setSize(500,300);
    this.add(c);

    // notifies to the component frame that if a peer is required, 
    // it should be created
    this.addNotify(); 

    //creates the offscreen image
    Image img = c.createImage(615,400);

    // gets image's grpahics context and then paints plot to it
    Graphics g = img.getGraphics();
    myplot.paint(g);

   // GIFEncoder encode = new GIFEncoder(img);
    //String filename = "/FTP/retrieve/w3browse/w3plot-" + pnum + ".gif";
    //OutputStream output = new BufferedOutputStream(new FileOutputStream(filename));
    //encode.Write(output);

   }

}
