#!/usr1/local/bin/perl5 -T 
#
# $Id: w3browse.pl,v 1.72 2008/06/03 17:02:02 lmm Exp $
# $Log: w3browse.pl,v $
# Revision 1.72  2008/06/03 17:02:02  lmm
# Added Notification Service link.
#
# Revision 1.71  2007/10/22 14:23:40  lmm
# Removed "New" from Keyword Search link.  Added a stub for future
#   announcements.
#
# Revision 1.70  2006/02/22 19:08:51  lmm
# Added Keyword Search to list of other interfaces.
#
# Revision 1.69  2005/06/16 14:36:23  lmm
# Added "updated" notice for Batch Interface
#
# Revision 1.68  2004/01/16 14:23:18  lmm
# Button label change for consistency
#
# Revision 1.67  2004/01/15 18:09:52  lmm
# Separated Query Upload button from Other Browse Interfaces list
#
# Revision 1.66  2003/12/02 22:13:20  lmm
# Changed CGI GET method to POST to allow file uploads.
# Added button for Query Upload and form element for target File upload.
#
# Revision 1.65  2003/08/28 19:48:12  lmm
# Added flag for HEASARC banner display and defined text to use
#   for the next page header
#
# Revision 1.64  2003/05/20 17:39:39  cwh
# No longer offering the old interface.
#
# Revision 1.63  2002/09/13 18:20:40  cwh
# Setting formname in variable, passing formname to javascript function.
#
# Revision 1.62  2002/04/11 17:53:14  cwh
# Minor html changes.
#
# Revision 1.61  2002/03/15 23:14:40  cwh
# Fixed html bug.
#
# Revision 1.60  2002/02/14 17:15:56  cwh
# HTML clean-up: Changed all instances of the <font> element to <span>.
#      Added type="text/javascript" to all <script> elements.
#
# Revision 1.59  2001/12/04 16:11:00  cwh
# Now prints HEASARC Browse.
#
# Revision 1.58  2001/11/08 19:53:28  cwh
# Changed 'do w3config.pl' to 'use Config' and AlwaysRun().
# Added Browse:: to all sub calls.
# Added QUERY_STRING to navtrail for w3browse link, so that the template and
#  any other settings are preserved.
# Added $::cgi to old interface link.
#
# Revision 1.57  2001/10/25 20:30:53  cwh
# Changed spaces to no-breaking spaces in the nav trail, since on IE it
#   was breaking the line between each step in the trail!!
# Added a link to get back to the old interface.
#
# Revision 1.56  2001/10/16 20:05:53  cwh
# Changed label in navtrail from 'CHoose Missions' to 'Main Search Form', since
# the main form is no longer just a mission selection form anymore.
#
# Revision 1.55  2001/09/15 02:40:52  cwh
# Cleaned out the code.
# Got rid of HDB::Observatories call, since that isn't used.
# State of variables passed in is honored.
#
# Revision 1.54  2001/07/31 14:57:58  cwh
# Now accepts template forms in querystring, reads in with includefile().
#
# Revision 1.53  2001/06/20 22:57:23  cwh
# Got rid of $::writeHeader in calls to ::Error.
#
# Revision 1.52  2001/05/24 16:50:28  cwh
# Oops.  typed 'use dir' instead of 'use lib dir'.
#
# Revision 1.51  2001/05/24 16:40:44  cwh
# This mod_perl stuff is killing me.  Got rid of all the BEGIN blocks (those aren't
# called if they've been already done once).  Added the 'use lib "./lib";'s back in.
#
# Revision 1.50  2001/05/03 19:08:26  cwh
# Put call to w3config.pl in a BEGIN statement, pulled all 'use lib's out.
#
# Revision 1.49  2001/04/03 15:35:14  cwh
# Added pageCheck back in, and added a bit of javascript so that pressing the
# Advanced button would not require that the Entry field be filled in.
#
# Revision 1.48  2001/03/12 16:14:35  cwh
# Modifications for combined interface:
#  - changed title of interface from Advanced to Main.
#  - changed the version substitution to the full eval of the page source.
#  - also made $form a relative url
#
# Revision 1.47  2001/01/02 22:59:17  cwh
# Added span info for navtrail so it uses css.
#
# Revision 1.46  2000/12/04 19:37:52  cwh
# Added navtrail variable which is passed from script to script to give users
# some navigation.
#
# Revision 1.45  2000/03/08 20:05:16  saima
# W3Browse to Browse name change.
#
# Revision 1.44  1999/10/21 17:48:27  saima
# Added some debug statements.
#
# Revision 1.43  1999/09/03 20:26:39  saima
# Removed extra print statement.
#
# Revision 1.42  1999/08/25 21:28:32  saima
# Minor tweaks in debug comments.
#
# Revision 1.41  1999/05/27 15:22:31  tam
# Modified to run under mod_perl apache server.  Using nominally obsolete 'do'
#   command rather than require.  All references to &smart routine delete.
#   Modifed form to use relative reference.  Eliminated old version comments.
#
# Revision 1.40  1998/12/23 20:07:48  saima
# The $::version is parsed from w3browse-form-tables.html and displayed.
#
# Revision 1.39  1998/12/21 19:38:44  saima
# Modified link to next page.
##
#=======================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA's Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name & address intact.
#=======================================================================#
# Module Name:    w3browse.pl
# Module Author:  Alan Richmond, Hughes STX
# Date:           Sept, 95
# Project:        Browse : HEASARC
#=======================================================================#
# Module Description:
#  Display Initial Form.
#  Give mission options and choice of search method.
#
#=======================================================================#
# Outline:
#
#
#
#=======================================================================#
#$::debug=1;
use strict;
use lib './lib/';

use Browse::ValidateInput;
use Browse::Options;
use Browse::Config;

$0 = 'w3browse.pl'; #Required for MailMessage - do not remove

#------------------------------------------------------------------------
$| = 1;
print Browse::CGI::Header(),"w3browse: DEBUG MODE<br>\n" if $::debug;
Browse::Config::AlwaysRun();
Browse::Decor::Header("HEASARC Browse",1,2,1); # dont close table, 
                                               # cols=2, use banner

my($in) = Browse::CGI::ReadParse();
BuildMissionForm();
Browse::Decor::Footer();

#end of main
#------------------------------------------------------------------------
sub BuildMissionForm {

    $ENV{PATH} = "/bin/";
    my $formname="w3browse";
    #print "Other Browse interfaces: <a href='$::w3bdocs/w3batchinfo.html'>" .
	#"Batch</a> | <a href='w3fullcross.pl'>Correlation</a> | " .
	#"<a href='w3catindex.pl'>Index of all tables</a>" ;

# file upload button 
print <<UPLOAD;
<form method="POST" name="uploadfile" 
   action="w3browse_uploads.pl">
UPLOAD


print "<table width='100%'><tr><td align='left'>Other Browse interfaces:<br>" .
	" <a href='notification/monitor_src.pl'>" .
	"Notification Service</a> <span style='color:red;font-size:80%'>New!</span> |" .
	" <a href='$::w3bdocs/w3batchinfo.html'>" .
	"Batch</a> |" .
	" <a href='w3fullcross.pl'>Correlation</a> | " .
	"<a href='w3catindex.pl'>Index of all tables</a> |" .
	" <a href='$::w3bdocs/browse.html'>" .
	"<nowrap>Keyword Search</a> </nowrap>" .
	"</td>" ;

#-- Upload query button, seperated from Other Browse Interfaces
print <<UPLOAD;
<td align='right'>
<input type="submit" name="Action" value="Query File And Session Uploads">
</td></tr></table>
</form>
UPLOAD


    print "<p>";
    #print "<form method='GET' action='w3table.pl' name='$formname' onSubmit=\"return(pageCheck());\">\n";

    # Change to POST to use multipart encoding for file upload
    print "<form method='POST' enctype='multipart/form-data'  action='w3table.pl' name='$formname' onSubmit=\"return(pageCheck());\">\n";

    print "<script type=\"text/javascript\" language=\"javascript\">var adv_query=0;</script>";
my $navtrail = "<span class='navcurrent'>Main&nbsp;Search&nbsp;Form</span>&nbsp;<span class='navfuture'>&gt;&nbsp;Search&nbsp;Results&nbsp;&gt;&nbsp;Choose&nbsp;Data&nbsp;Products</span>";
print "$navtrail<br>\n";
$navtrail = "&lt;a class='navpast' href='".$ENV{SCRIPT_NAME}.'?'.$ENV{QUERY_STRING}."' &gt; Main Search Form&lt;/a&gt;";
print "<input type='hidden' name='navtrail' value=\"$navtrail\">";
print "<input type='hidden' name='popupForm' value='Query Results'>";

    Browse::ValidateInput::checkMissions($formname);  #adds JavaScript code to check form input
    print "<script type=\"text/javascript\" language=\"JavaScript\">\n";
    #print "<!-- \n";
    Browse::ValidateInput::tickTable();
    print "</script>\n";
    #print "<p><table border='1'><tr><td><b>Announcements</b>: ";
    #print "We apologize for the inconvenience .</td></tr></table>\n";

    # get the template file read in, with any included files
    my($form) = "w3browse-form-tables.html";
    $form = $in->{'template'} if $in->{'template'} and -s $in->{'template'};
    $form =~ s/\.\.\///g;  # '../' not allowed!
    $form = $in->{'template'} if $in->{'template'} and -s $in->{'template'};
    ($form) = $form =~ /([\w\.\-]+)/;
    $form = $in->{'template'} if $in->{'template'} and -s $in->{'template'};
    my($state) = Browse::Options::BuildState($in);
    my $slurp = Browse::Utils::includefile($form);

    # evaluate variables in the template file
    ($slurp) = $slurp =~ /(.*)/s;  #blindly untaint $slurp
    $slurp = "print <<EoF;\n$slurp\nEoF";
    eval $slurp; warn "eval: $@" if $@;
print "</form>";

} #eosub--BuildMissionForm
#------------------------------------------------------------------------

#########
#  EOF  #
#########
