#!/usr1/local/bin/perl5 -T
# $Id: w3plot.pl,v 1.9 2001/11/08 19:57:41 cwh Exp $
# Revision 1.6  2001/05/03 19:15:46  cwh
# Put call to w3config.pl in a BEGIN statement, pulled all 'use lib's out.
#
# Revision 1.5  2000/08/15 17:25:51  saima
# The plotting application now uses java 1.2.2 instead of java 1.1.8. The
#   server-side application does not require an X server to plot/create
#   the GIF. Instead, it uses a PJA package which can do the graphics
#   without an X server.
#
# Revision 1.4  2000/03/08 20:03:47  saima
# W3Browse to Browse name change.
#
# Revision 1.3  1999/09/24 18:42:09  saima
# Added debugging statements.
#
# Revision 1.2  1999/09/08 20:20:34  saima
# Modified the server-side form so that sample-data information
#   is added.
#
# Revision 1.1  1999/09/07 19:04:05  saima
# Plotting is not displayed on the Results page anymore. An icon
#   starts up another browser window which displays the plotting
#   utility.
#
#
#=======================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA's Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name & address intact.
#=======================================================================#
# Module Name:    w3plot.pl
# Module Author:  Saima Zobair, Raytheon ITSS 
# Date:           August 20, 99
# Project:        Browse : HEASARC
#=======================================================================#
# Module Description:
#
#=======================================================================#

use strict;
use lib './lib';

use Browse::Config;
use Browse::Java;
use DateTime;

Browse::Config::AlwaysRun();

$0 = 'w3plot.pl'; # Required for MailMessage. Do not remove.
#------------------------------------------------------------------------
$| = 1; # Make STDOUT unbuffered.
#$::debug = 1;

my($in) = Browse::CGI::ReadParse();

my $ra      = $$in{ra};
my $dec     = $$in{dec};
my $numeric = $$in{numeric};
my $coordsys= $$in{Coordinate};
my $equinox = $$in{Equinox};
my $request = $$in{request};
my $server  = $$in{server};

Browse::Java::DoPlot($ra, $dec, $numeric, $coordsys, $equinox, $request, $server, $in);

# End of main
#------------------------------------------------------------------------

1;
#########
#  EOF  #
#########
