#!/usr1/local/bin/perl5 -T
# $Id: w3tar.pl,v 1.12 2006/03/07 21:05:16 lmm Exp $
# $Log: w3tar.pl,v $
# Revision 1.12  2006/03/07 21:05:16  lmm
# Switched Save to Hera processing from saveFile.pm to ProdHera.pm
#
# Revision 1.11  2004/12/06 16:56:51  lmm
# Added flag for Download Script To File option
#
# Revision 1.10  2004/10/05 18:32:55  lmm
# Added determination of ProdMain subclass for HProdScriptGen
#
# Revision 1.9  2002/09/13 19:06:57  cwh
# Removed error message from error printed for users.
#
# Revision 1.8  2002/09/13 19:06:27  cwh
# Now using ProdMain/ProdGen modules.
#
# Revision 1.7  2002/02/14 17:18:26  cwh
# Added action for Save to Hera.
# Fixed bug - MailMessage() is in module MailMessage, not Utils.
#
# Revision 1.6  2001/11/08 19:57:41  cwh
# Changed 'do w3config.pl' to 'use Config' and AlwaysRun().
# Added Browse:: to all sub calls.
#
# Revision 1.5  2001/10/25 20:29:13  cwh
# Put Products::writeTar in an eval, mailing and warning the user if it fails.
#
# Revision 1.4  2001/05/24 16:40:45  cwh
# This mod_perl stuff is killing me.  Got rid of all the BEGIN blocks (those aren't
# called if they've been already done once).  Added the 'use lib "./lib";'s back in.
#
# Revision 1.3  2001/05/22 17:57:12  cwh
# Added Id, Log to those scripts that needed it.
#
#
#=======================================================================#
# Module Description:
# This module tars files slated for retrieval and gives the user
# a download option.
#
#=======================================================================#
$0 = 'w3tar.pl'; # Required for MailMessage - do not remove.

use strict;
use lib './lib';

use Browse::Config;
use Browse::ProdMain;
use Browse::saveFile;
use Benchmark;

Browse::Config::AlwaysRun();
#$::debug=1;
#------------------------------------------------------------------------
$| = 1; # Make STDOUT unbuffered.

if ($::debug) {print "Content-type: text/html\n\n";}
my($in) = Browse::CGI::ReadParse();

if ($::debug) {
   print "w3tar:<br>";
   Browse::Utils::DumpRef($in); 
}


#if ($$in{'Save to Hera'}) {
   #Browse::saveFile::saveFile($in);
   #exit;
#} 

if ($$in{'Download Script To File'}) {
   $$in{"files"} = "scriptfile";
} elsif ($$in{'Create Download Script'}) {
   $$in{"files"} = "script";
} elsif ($$in{'Save to Hera'}) {
   $$in{"files"} = "analyze";
} else {
   $$in{"files"} = "write";
}


eval {
  my $dp = new Browse::ProdMain($in);
  $dp->doProducts($in);
};

if ($@) {
  Browse::MailMessage::MailMessage("w3tar.pl's eval of ProdGen failed! $@",$::addr) and
  Browse::Utils::Error("Error initiating tarfile.  Email has been sent to the maintainers. ");
}

#########
#  EOF  #
#########
